// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Scheme;
import bdc.scheme.SchemeException;
import bdc.scheme.Stack;
import bdc.scheme.expression.Procedure0;
import bdc.util.Constants;
import bdc.util.SystemUtil;

/**
    Primitive for System.exit
*/
public class Exit extends Procedure0
{
    public Object apply0 (Stack stack) throws SchemeException
    {
        try {
            stack.addElement(Constants.ZeroInteger);
            return apply1(stack);
        }
        finally {
            stack.inUse -= 1;
        }
    }

    public Object apply1 (Stack stack) throws SchemeException
    {
        Object o1 = stack.array[stack.inUse-1];
        SystemUtil.exit(Scheme.integer(o1, this));
        return Scheme.Unspecified;
    }
}
